package com.yizhi.application.portal.controller;

import com.yizhi.site.application.feign.api.EventTrackApiClients;
import com.yizhi.site.application.vo.site.DayNumVo;
import com.yizhi.site.application.vo.site.EventTrackDayNumVo;
import com.yizhi.site.application.vo.site.EventTrackDeptNumVo;
import com.yizhi.site.application.vo.site.EventTrackTypeNumVo;
import com.yizhi.util.application.domain.Response;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * com.yizhi.site.application.controller.api
 *
 * @author yanglang
 * @create 2025-01-14 10:57:55
 */
@RestController
@RequestMapping("/manage/api/eventTrack")
public class EventTrackManageController {

    @Autowired
    private EventTrackApiClients eventTrackApiClients;


    @GetMapping("/addEvent")
    public Response addEvent(@RequestParam("type") String type, @RequestParam("businessId") Long businessId){
        eventTrackApiClients.addEvent(type,businessId);
        return Response.ok();
    }


    @GetMapping("/getTodayNum")
    public Response<EventTrackDayNumVo> getTodayNum(@RequestParam(value = "date",required = false) String date){
        return Response.ok(eventTrackApiClients.getTodayNum(date));
    }

    @GetMapping("getNumByType")
    public Response<DayNumVo> getNumByType(@RequestParam(value = "date",required = false) String date, @RequestParam("types") List<Integer> types){
        return Response.ok(eventTrackApiClients.getNumByType(date,types));
    }

    @GetMapping("/queryNumByType")
    public Response<List<EventTrackTypeNumVo>> queryNumByType(@RequestParam(value = "date",required = false) String date, @RequestParam("types")List<Integer> types){
        return Response.ok(eventTrackApiClients.queryNumByType(date,types));
    }

    @GetMapping("/queryDeptByType")
    public Response<List<EventTrackDeptNumVo>> queryDeptByType(@RequestParam(value = "date",required = false) String date, @RequestParam("types")List<Integer> types){
        return Response.ok(eventTrackApiClients.queryDeptByType(date,types));
    }
}
